import httplib2
import os
import time

from apiclient import discovery
from google.oauth2 import service_account

from Utils.settings import settings

class GoogleSheetsAPI:
    def __init__(self, conf_path):
        self.data = settings(conf_path)

        scopes = ["https://www.googleapis.com/auth/drive",
              "https://www.googleapis.com/auth/drive.file",
              "https://www.googleapis.com/auth/spreadsheets"
              ]

        secret_file = os.path.join(os.getcwd(), 'GoogleAPI', 'creds.json')
        credentials = service_account.Credentials.from_service_account_file(secret_file, scopes=scopes)
        self.service = discovery.build(self.data.return_data()['api'],
                                       self.data.return_data()['version'],
                                       credentials=credentials,
                                       cache_discovery=False)
        self.data = settings(conf_path)

    def get_preset(self):
        return self.service.spreadsheets().values().get(
            spreadsheetId=self.data.return_data()['spreadsheet_id'],
            range=self.data.return_data()['preset_field']).execute().get('values', [])[0][0]

    def update_cameras_list(self, data):
        return self.service.spreadsheets().values().update(spreadsheetId=self.data.return_data()['spreadsheet_id'],
                                               body=data,
                                               range=self.data.return_data()['cameras_fields'],
                                               valueInputOption='USER_ENTERED').execute()