import os
import json

from django.core.management.base import BaseCommand
from django.core.management import call_command
#from django.conf import settings

from Utils.utils import go_up

class Command(BaseCommand):
    help = 'Run custom server with args'

    def add_arguments(self, parser):
        parser.add_argument(
            'ip',
            type=str,
            help='IP for instance'
        )

        parser.add_argument(
            'port',
            type=str,
            help='Port for instance'
        )

        parser.add_argument(
            'conf_path',
            type=str,
            help='Path to conf file'
        )

        parser.add_argument(
            'cam_num',
            type=str,
            help='Camera number (1, 2, 3, ...)'
        )

        parser.add_argument(
            'sub_instance_list_path',
            type=str,
            help='Path to list of sub instances, 0 if sub instance'
        )

    def handle(self, *args, **kwargs):
        global csettings
        csettings = {
            'start_ip': kwargs['ip'],
            'start_port':  kwargs['port'],
            'conf_path': kwargs['conf_path'],
            'cam_num': kwargs['cam_num'],
            'sub_instance_list_path': kwargs['sub_instance_list_path']
        }
        print(go_up(os.path.dirname(__file__), 3))
        with open(os.path.join(go_up(os.path.dirname(__file__), 3), 'start_conf.json'), 'w') as file:
            json.dump(csettings, file)
        #csettings.start_ip = kwargs['ip']
        #csettings.start_port = kwargs['port']
        #csettings.conf_path = kwargs['conf_path']
        #csettings.cam_num = kwargs['cam_num']
        #csettings.sub_instance_list_path = kwargs['sub_instance_list_path']
        call_command('runserver', '0.0.0.0:{}'.format(kwargs['port']))
