import os
import time
import logging

from googleapiclient.errors import HttpError
from subprocess import call

from Utils.settings import settings
from GoogleAPI.googleApi import GoogleSheetsAPI

logging.basicConfig(level=logging.INFO)

while True:
    try:
        onvif_proxy_conf_path = os.path.join(os.path.dirname(__file__),
                                             'Onvif_proxy',
                                             'apps',
                                             'onvif_proccesser',
                                             'conf.json')
        data = settings(onvif_proxy_conf_path)

        GoogleApi = GoogleSheetsAPI(onvif_proxy_conf_path)

        google_preset = GoogleApi.get_preset()

        if data.return_data()['default'] != google_preset and google_preset in list(data.return_data()["remote_controller"].keys()):
            logging.info('Смена пресета на {}'.format(google_preset))

            data.change_default(google_preset)
            data.dump_to_conf()

            keys = list(data.return_data()["remote_controller"][data.return_data()['default']].keys())

            to_print = []

            for key in sorted(keys, key=int):
                to_print.append([key,
                                data.return_data()["remote_controller"][data.return_data()['default']][key]['ip'],
                                data.return_data()["remote_controller"][data.return_data()['default']][key]['port'],
                                data.return_data()["remote_controller"][data.return_data()['default']][key]['streamuri']
                                ])
            for i in range(12 - len(to_print)):
                to_print.append(["", "", "", ""])
            data = {
                'values': to_print
            }

            GoogleApi.update_cameras_list(data)

            #call(["systemctl", "restart", "onvif-proxy"])
            os.system("sudo systemctl restart onvif-proxy")

        else:
            logging.info('Пресет менять не нужно')
            time.sleep(60)
    except HttpError as err:
        logging.info(err)
